## API Report File for "@fluentui/react-combobox"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import type { ComponentProps } from '@fluentui/react-utilities';
import type { ComponentState } from '@fluentui/react-utilities';
import type { ForwardRefComponent } from '@fluentui/react-utilities';
import type { PositioningShorthand } from '@fluentui/react-positioning';
import * as React_2 from 'react';
import type { Slot } from '@fluentui/react-utilities';
import { SlotClassNames } from '@fluentui/react-utilities';

// @public
export const Combobox: ForwardRefComponent<ComboboxProps>;

// @public (undocumented)
export const comboboxClassNames: SlotClassNames<ComboboxSlots>;

// @public (undocumented)
export type ComboboxContextValues = {
    combobox: ComboboxContextValue;
};

// @public
export type ComboboxOpenChangeData = {
    open: boolean;
};

// @public (undocumented)
export type ComboboxOpenEvents = React_2.MouseEvent<HTMLElement> | React_2.KeyboardEvent<HTMLElement>;

// @public
export type ComboboxProps = ComponentProps<Partial<ComboboxSlots>, 'trigger'> & ComboboxCommons & SelectionProps & {
    defaultOpen?: boolean;
    defaultValue?: string;
    onOpenChange?: (e: ComboboxOpenEvents, data: ComboboxOpenChangeData) => void;
    positioning?: PositioningShorthand;
};

// @public (undocumented)
export type ComboboxSlots = {
    root: NonNullable<Slot<'div'>>;
    listbox: NonNullable<Slot<typeof Listbox>>;
    trigger: NonNullable<Slot<typeof ComboButton>>;
};

// @public
export type ComboboxState = ComponentState<ComboboxSlots> & Required<Pick<ComboboxCommons, 'appearance' | 'open' | 'inline' | 'size'>> & Pick<ComboboxCommons, 'placeholder' | 'value'> & OptionCollectionState & SelectionState & {
    activeOption?: OptionValue;
    idBase: string;
    onOptionClick(event: React_2.MouseEvent, option: OptionValue): void;
};

// @public
export const ComboButton: ForwardRefComponent<ComboButtonProps>;

// @public (undocumented)
export const comboButtonClassNames: SlotClassNames<ComboButtonSlots>;

// @public
export type ComboButtonProps = Partial<ComponentProps<ComboButtonSlots, 'content'>> & ComboButtonCommons;

// @public (undocumented)
export type ComboButtonSlots = {
    root: NonNullable<Slot<'div'>>;
    content: NonNullable<Slot<'button'>>;
    expandIcon: Slot<'span'>;
};

// @public
export type ComboButtonState = ComponentState<ComboButtonSlots> & ComboButtonCommons & Pick<ComboboxState, 'appearance' | 'size'>;

// @public
export const Listbox: ForwardRefComponent<ListboxProps>;

// @public (undocumented)
export const listboxClassNames: SlotClassNames<ListboxSlots>;

// @public (undocumented)
export type ListboxContextValues = {
    listbox: ListboxContextValue;
};

// @public
export type ListboxProps = ComponentProps<ListboxSlots> & SelectionProps;

// @public (undocumented)
export type ListboxSlots = {
    root: Slot<'div'>;
};

// @public
export type ListboxState = ComponentState<ListboxSlots> & OptionCollectionState & SelectionState & {
    activeOption?: OptionValue;
    idBase: string;
    onOptionClick(event: React_2.MouseEvent, option: OptionValue): void;
};

// @public
const Option_2: ForwardRefComponent<OptionProps> & {
    fluentComponentType?: string;
};
export { Option_2 as Option }

// @public (undocumented)
export const optionClassNames: SlotClassNames<OptionSlots>;

// @public
export const OptionGroup: ForwardRefComponent<OptionGroupProps> & {
    fluentComponentType?: string;
};

// @public (undocumented)
export const optionGroupClassNames: SlotClassNames<OptionGroupSlots>;

// @public
export type OptionGroupProps = ComponentProps<Partial<OptionGroupSlots>>;

// @public (undocumented)
export type OptionGroupSlots = {
    root: NonNullable<Slot<'div'>>;
    label?: Slot<'span'>;
};

// @public
export type OptionGroupState = ComponentState<OptionGroupSlots>;

// @public
export type OptionProps = ComponentProps<Partial<OptionSlots>> & OptionCommons & {
    fluentKey?: string;
    value?: string;
};

// @public (undocumented)
export type OptionSlots = {
    root: NonNullable<Slot<'div'>>;
    checkIcon: Slot<'span'>;
};

// @public
export type OptionState = ComponentState<OptionSlots> & OptionCommons & {
    active: boolean;
    multiselect?: boolean;
    selected: boolean;
};

// @public
export const renderCombobox_unstable: (state: ComboboxState, contextValues: ComboboxContextValues) => JSX.Element;

// @public
export const renderComboButton_unstable: (state: ComboButtonState) => JSX.Element;

// @public
export const renderListbox_unstable: (state: ListboxState, contextValues: ListboxContextValues) => JSX.Element;

// @public
export const renderOption_unstable: (state: OptionState) => JSX.Element;

// @public
export const renderOptionGroup_unstable: (state: OptionGroupState) => JSX.Element;

// @public
export const useCombobox_unstable: (props: ComboboxProps, ref: React_2.Ref<HTMLButtonElement>) => ComboboxState;

// @public
export const useComboboxStyles_unstable: (state: ComboboxState) => ComboboxState;

// @public
export const useComboButton_unstable: (props: ComboButtonProps, ref: React_2.Ref<HTMLButtonElement>) => ComboButtonState;

// @public
export const useComboButtonStyles_unstable: (state: ComboButtonState) => ComboButtonState;

// @public
export const useListbox_unstable: (props: ListboxProps, ref: React_2.Ref<HTMLElement>) => ListboxState;

// @public
export const useListboxStyles_unstable: (state: ListboxState) => ListboxState;

// @public
export const useOption_unstable: (props: OptionProps, ref: React_2.Ref<HTMLElement>) => OptionState;

// @public
export const useOptionGroup_unstable: (props: OptionGroupProps, ref: React_2.Ref<HTMLElement>) => OptionGroupState;

// @public
export const useOptionGroupStyles_unstable: (state: OptionGroupState) => OptionGroupState;

// @public
export const useOptionStyles_unstable: (state: OptionState) => OptionState;

// (No @packageDocumentation comment for this package)

```
