## API Report File for "@fluentui/react-positioning"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import type { GriffelStyle } from '@griffel/react';
import * as PopperJs from '@popperjs/core';
import * as React_2 from 'react';

// @public (undocumented)
export type Alignment = 'top' | 'bottom' | 'start' | 'end' | 'center';

// @public (undocumented)
export type AutoSize = 'height' | 'height-always' | 'width' | 'width-always' | 'always' | boolean;

// @public (undocumented)
export type Boundary = PopperJs.Boundary | 'scrollParent' | 'window';

// @public
export function createArrowHeightStyles(arrowHeight: number): {
    width: string;
    height: string;
};

// @public
export function createArrowStyles(options: CreateArrowStylesOptions): GriffelStyle;

// @public
export type CreateArrowStylesOptions = {
    arrowHeight: number | undefined;
    borderWidth?: GriffelStyle['borderBottomWidth'];
    borderStyle?: GriffelStyle['borderBottomStyle'];
    borderColor?: GriffelStyle['borderBottomColor'];
};

// @public
export function createVirtualElementFromClick(nativeEvent: MouseEvent): PopperVirtualElement;

// @public
export function mergeArrowOffset(userOffset: Offset | undefined | null, arrowHeight: number): Offset;

// @public (undocumented)
export type Offset = OffsetFunction | [number | null | undefined, number | null | undefined];

// @public (undocumented)
export type OffsetFunction = (param: OffsetFunctionParam) => [number | null | undefined, number | null | undefined];

// @public (undocumented)
export type OffsetFunctionParam = {
    popper: PopperJs.Rect;
    reference: PopperJs.Rect;
    placement: PopperJs.Placement;
};

// @public (undocumented)
export interface PopperOptions {
    align?: Alignment;
    arrowPadding?: number;
    autoSize?: AutoSize;
    coverTarget?: boolean;
    flipBoundary?: Boundary;
    offset?: Offset;
    overflowBoundary?: Boundary;
    pinned?: boolean;
    position?: Position;
    positionFixed?: boolean;
    unstable_disableTether?: boolean | 'all';
}

// @public (undocumented)
export type PopperRefHandle = {
    updatePosition: () => void;
    setTarget: (target: HTMLElement | PopperVirtualElement) => void;
};

// @public (undocumented)
export type PopperVirtualElement = PopperJs.VirtualElement;

// @public (undocumented)
export type Position = 'above' | 'below' | 'before' | 'after';

// @public (undocumented)
export interface PositioningProps extends Omit<PopperOptions, 'positionFixed' | 'unstable_disableTether'> {
    popperRef?: React_2.Ref<PopperRefHandle>;
    target?: HTMLElement | PopperVirtualElement | null;
}

// @public (undocumented)
export type PositioningShorthand = PositioningProps | PositioningShorthandValue;

// @public (undocumented)
export type PositioningShorthandValue = 'above' | 'above-start' | 'above-end' | 'below' | 'below-start' | 'below-end' | 'before' | 'before-top' | 'before-bottom' | 'after' | 'after-top' | 'after-bottom';

// @public (undocumented)
export function resolvePositioningShorthand(shorthand: PositioningShorthand | undefined | null): Readonly<PositioningProps>;

// @public
export function usePopper(options?: UsePopperOptions): {
    targetRef: React_2.MutableRefObject<any>;
    containerRef: React_2.MutableRefObject<any>;
    arrowRef: React_2.MutableRefObject<any>;
};

// @public
export const usePopperMouseTarget: (initialState?: PopperJs.VirtualElement | (() => PopperJs.VirtualElement) | undefined) => readonly [PopperJs.VirtualElement | undefined, (event: React_2.MouseEvent | MouseEvent | undefined | null) => void];

// (No @packageDocumentation comment for this package)

```
